package UroIrmPackage;

import ij.*;

/**
	helps to manage all data from the class HeaderDicom that deals with time.
*/
public class UroIrmTime {
	int seconde;
	public static String ANORMAL = "anormal";	
	private static String H = " h ";
	private static String M = " min ";
	private static String S = " s ";

	String nom_class = " time ";
	String msg_err_time = nom_class + "  -> le format du temps n'est pas respecte";
	String msg_err_time_NFE = "Pointeur Null \n" + msg_err_time;

	public UroIrmTime(int s){
		this.seconde = s;
	}
	
	public UroIrmTime(String temps){
		if (temps == null || temps.equals(ANORMAL)) 
			this.seconde = -1;
		else
			this.seconde = ToSeconde(temps);
	}

/** returns the time in second */
	public int getValue(){
		return(this.seconde);
	}

/** convert the time in string ( such as HHMMSS ou MMSS ou SS) in second (int) */
	private int ToSeconde(String temps){
		int indice_heure =-1;	
		int indice_min =-1;	
		int indice_sec =-1;	
		int heure,minute,seconde,resultat ;
		
		
		heure =0; minute =0 ; seconde =0 ; resultat=0;

		try {
			indice_heure = temps.indexOf(H);
			indice_min = temps.indexOf(M);
			indice_sec = temps.indexOf(S);

			if ( indice_sec <0 ){
				if (temps.equals(ANORMAL) ) 
					IJ.error(msg_err_time);
					return -1;
			}

			if ( indice_heure > 0 ){
				heure = Integer.parseInt(temps.substring(0,indice_heure));
				minute = Integer.parseInt(temps.substring(indice_heure+H.length(),indice_min));
				seconde = Integer.parseInt(temps.substring(indice_min+M.length(),indice_sec));	
			} else {
			 	if ( indice_min > 0 ){
					minute = Integer.parseInt(temps.substring(0,indice_min));
					seconde = Integer.parseInt(temps.substring(indice_min+M.length(),indice_sec));	
				} else {
					if ( indice_sec > 0 ){
						seconde = Integer.parseInt(temps.substring(0,indice_sec));	
					}
				}
			}
				
			return (heure * 3600 + minute *60 + seconde) ;		

		}catch (NumberFormatException e ) {
			IJ.error(msg_err_time_NFE);
			return -1;
		}
		
	}


/** give a nice presentation of the time */   
	public String toString (){
		int heure , minute , seconde;	
		if ( this.seconde < 0 ) {
			return ANORMAL;
		}
		
		heure = this.seconde / 3600 ; 
		minute = (this.seconde - heure *3600) /60 ; 
		seconde = this.seconde - heure *3600 - minute *60 ;
		if ( heure !=0  )
			return (String.valueOf(heure) + H
				+ String.valueOf(minute) + M 
				+ String.valueOf(seconde) + S );
		if ( minute != 0 )
			return (String.valueOf(minute) + M 
				+ String.valueOf(seconde) + S );

		return (String.valueOf(seconde) + S );
	}


}


